package ru.landgrafhomyak.db.serdha0.api.misc

import ru.landgrafhomyak.db.serdha0.api.queries._Query
import ru.landgrafhomyak.db.serdha0.api.runtime.OutputRow
import ru.landgrafhomyak.db.serdha0.api.table.RowId
import ru.landgrafhomyak.db.serdha0.api.table.Table

public interface RowExpression<ttUE : Any, @Suppress("unused") R> {
	public val targetTable: Table<ttUE, *>

	public interface RowExportsConstructor<rUE : Any, ttUE : Any> {
		public fun createRowExports(context: Scope<rUE, ttUE>): rUE

		public interface Scope<rUE : Any, ttUE : Any> {
			public val tt: Table<ttUE, *>

			public fun <RT, DT : DatabaseType<RT>> selectFromTargetTable(column: Column<RT, DT, ttUE>): Column<RT, DT, rUE>

			public fun <rtUE : Any, RT, DT : DatabaseType<RT>> followReference(
				ref: Column<*, *, rUE>,
				column: Column<RT, DT, rtUE>
			): Column<RT, DT, rUE>

			public fun <rtUE : Any, RT : Any, DT : DatabaseType<RT>> followReferenceNullable(
				ref: Column<RowId<rtUE>, DatabaseType.ROW_ID<rtUE>, rUE>,
				column: Column<RT, DT, rtUE>
			): Column<RT?, DatabaseType.Nullable<RT, DT>, rUE>
		}
	}

	public interface Constructor<ttUE : Any, rUE : Any, R> {
		public val rowExports: RowExportsConstructor<rUE, ttUE>

		public fun createRowExpression(internalQueries: _Query.Constructor._SelectsScope, runtimeQueries: _Query.Constructor._SelectsScope): Action<rUE, R>
	}

	public interface Action<rUE : Any, R> {
		public suspend fun calculateRow(rowUE: rUE, row: OutputRow<rUE>): R
	}
}